# -*- coding: iso-8859-1 -*-
# generated by wxGlade 0.6.3 on Mon Oct 18 21:21:44 2010

import os
import wx

class ScummTrDialog(wx.Dialog):
    def __init__(self, *args, **kwds):
        # begin wxGlade: ScummTrDialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.szrGameDir_staticbox = wx.StaticBox(self, -1, "Game directory")
        self.szPadding_staticbox = wx.StaticBox(self, -1, "Padding")
        self.szOptions_staticbox = wx.StaticBox(self, -1, "ScummTr Options")
        self.szrText_staticbox = wx.StaticBox(self, -1, "Text file")
        self.lblGameId = wx.StaticText(self, -1, "Game ID: ", style=wx.ALIGN_CENTRE)
        self.comboGameId = wx.ComboBox(self, -1, choices=["maniacv1", "zakv1", "maniacv2", "zakv2", "indy3", "indy3mac", "loom", "indy3towns", "indy3vga", "zaktowns", "loomtowns", "monkey", "loomcd", "monkeycd", "monkeycdalt", "monkeysega", "monkey2", "atlantis", "tentacle", "samnmax", "samnmaxalt", "ft", "dig"], style=wx.CB_DROPDOWN|wx.CB_READONLY)
        self.rbExtractInsert = wx.RadioBox(self, -1, "", choices=["Extract from game", "Insert into game"], majorDimension=2, style=wx.RA_SPECIFY_COLS)
        self.txtCtrlTextFile = wx.TextCtrl(self, -1, "")
        self.btnBrowseText = wx.Button(self, -1, "Browse")
        self.txtCtrlGameDir = wx.TextCtrl(self, -1, "")
        self.btnBrowseGameDir = wx.Button(self, -1, "Browse")
        self.cbWindowsNewlines = wx.CheckBox(self, -1, "Use the CrLf format for newlines (for Windows)")
        self.cbConvertToAnsi = wx.CheckBox(self, -1, "Convert characters to the ANSI charset")
        self.cbLanguage = wx.CheckBox(self, -1, "Language (for V1 && V2 games)")
        self.choiceLanguage = wx.Choice(self, -1, choices=["en", "de", "it", "fr"])
        self.cbBinaryMode = wx.CheckBox(self, -1, "Binary mode")
        self.cbAddLineHeaders = wx.CheckBox(self, -1, "Add line headers in exported text")
        self.cbHexCharCodes = wx.CheckBox(self, -1, "Hexadecimal char codes")
        self.cbShowOpcodes = wx.CheckBox(self, -1, "Show instruction opcodes")
        self.rbPadding = wx.RadioBox(self, -1, "", choices=["Don't pad", "Pad", "Pad, accounting for variable IDs"], majorDimension=0, style=wx.RA_SPECIFY_ROWS)
        self.cbPadObjects = wx.CheckBox(self, -1, "Objects")
        self.cbPadActors = wx.CheckBox(self, -1, "Actors")
        self.cbPadVerbs = wx.CheckBox(self, -1, "Verbs")
        self.OK = wx.Button(self, wx.ID_OK, "")
        self.Cancel = wx.Button(self, wx.ID_CANCEL, "")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_RADIOBOX, self.selectExtractInsert, self.rbExtractInsert)
        self.Bind(wx.EVT_BUTTON, self.buttonBrowseText, self.btnBrowseText)
        self.Bind(wx.EVT_BUTTON, self.buttonBrowseGameDir, self.btnBrowseGameDir)
        self.Bind(wx.EVT_CHECKBOX, self.checkboxLanguage, self.cbLanguage)
        # end wxGlade
        self.Bind(wx.EVT_RADIOBOX, self.selectPadding, self.rbPadding)

        self.output_options_list = [
            self.cbAddLineHeaders,
            self.cbHexCharCodes,
            self.cbShowOpcodes,
            self.rbPadding
        ]
        self.padding_options_list = [
            self.cbPadObjects,
            self.cbPadActors,
            self.cbPadVerbs
        ]

    def __set_properties(self):
        # begin wxGlade: ScummTrDialog.__set_properties
        self.SetTitle("ScummTr Options")
        self.comboGameId.SetSelection(-1)
        self.rbExtractInsert.SetSelection(0)
        self.cbWindowsNewlines.SetValue(1)
        self.cbConvertToAnsi.SetValue(1)
        self.choiceLanguage.Enable(False)
        self.choiceLanguage.SetSelection(0)
        self.cbHexCharCodes.SetValue(1)
        self.rbPadding.SetSelection(0)
        self.cbPadObjects.Enable(False)
        self.cbPadActors.Enable(False)
        self.cbPadVerbs.Enable(False)
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: ScummTrDialog.__do_layout
        szMain = wx.BoxSizer(wx.VERTICAL)
        szOkCancel = wx.BoxSizer(wx.HORIZONTAL)
        szOptions = wx.StaticBoxSizer(self.szOptions_staticbox, wx.VERTICAL)
        szPadding = wx.StaticBoxSizer(self.szPadding_staticbox, wx.VERTICAL)
        szPadOptions = wx.BoxSizer(wx.HORIZONTAL)
        szLanguage = wx.BoxSizer(wx.HORIZONTAL)
        szrGameDir = wx.StaticBoxSizer(self.szrGameDir_staticbox, wx.HORIZONTAL)
        szrText = wx.StaticBoxSizer(self.szrText_staticbox, wx.HORIZONTAL)
        szGameId = wx.BoxSizer(wx.HORIZONTAL)
        szGameId.Add(self.lblGameId, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        szGameId.Add(self.comboGameId, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        szOptions.Add(szGameId, 1, wx.ALIGN_CENTER_HORIZONTAL, 0)
        szOptions.Add(self.rbExtractInsert, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        szrText.Add(self.txtCtrlTextFile, 1, wx.ALIGN_CENTER_VERTICAL, 0)
        szrText.Add(self.btnBrowseText, 0, wx.ALIGN_RIGHT|wx.ALIGN_CENTER_VERTICAL, 0)
        szOptions.Add(szrText, 1, wx.ALL|wx.EXPAND, 5)
        szrGameDir.Add(self.txtCtrlGameDir, 1, wx.ALIGN_CENTER_VERTICAL, 0)
        szrGameDir.Add(self.btnBrowseGameDir, 0, wx.ALIGN_RIGHT|wx.ALIGN_CENTER_VERTICAL, 0)
        szOptions.Add(szrGameDir, 1, wx.ALL|wx.EXPAND, 5)
        szOptions.Add(self.cbWindowsNewlines, 0, 0, 0)
        szOptions.Add(self.cbConvertToAnsi, 0, 0, 0)
        szLanguage.Add(self.cbLanguage, 0, 0, 0)
        szLanguage.Add(self.choiceLanguage, 0, 0, 0)
        szOptions.Add(szLanguage, 0, wx.EXPAND, 0)
        szOptions.Add(self.cbBinaryMode, 0, 0, 0)
        szOptions.Add(self.cbAddLineHeaders, 0, 0, 0)
        szOptions.Add(self.cbHexCharCodes, 0, 0, 0)
        szOptions.Add(self.cbShowOpcodes, 0, 0, 0)
        szPadding.Add(self.rbPadding, 0, wx.EXPAND, 0)
        szPadOptions.Add(self.cbPadObjects, 0, 0, 0)
        szPadOptions.Add(self.cbPadActors, 0, 0, 0)
        szPadOptions.Add(self.cbPadVerbs, 0, 0, 0)
        szPadding.Add(szPadOptions, 0, wx.ALIGN_RIGHT, 0)
        szOptions.Add(szPadding, 0, wx.EXPAND, 3)
        szMain.Add(szOptions, 1, wx.EXPAND, 0)
        szOkCancel.Add(self.OK, 0, wx.ALIGN_BOTTOM, 0)
        szOkCancel.Add(self.Cancel, 0, wx.ALIGN_BOTTOM, 0)
        szMain.Add(szOkCancel, 0, wx.ALIGN_RIGHT|wx.ALIGN_BOTTOM, 0)
        self.SetSizer(szMain)
        szMain.Fit(self)
        self.Layout()
        # end wxGlade

    def selectExtractInsert(self, event): # wxGlade: ScummTrDialog.<event_handler>
        if self.rbExtractInsert.GetSelection() == 0:
            for elem in self.output_options_list:
                elem.Enable(True)
            if self.rbPadding.GetSelection() == 0:
                for elem in self.padding_options_list:
                    elem.Enable(True)
        elif self.rbExtractInsert.GetSelection() == 1:
            for elem in self.output_options_list:
                elem.Enable(False)
            for elem in self.padding_options_list:
                elem.Enable(False)

    def selectPadding(self, event):
        if self.rbPadding.GetSelection() == 0:
            for elem in self.padding_options_list:
                elem.Enable(False)
        else:
            for elem in self.padding_options_list:
                elem.Enable(True)

    def buttonBrowseText(self, event): # wxGlade: ScummTrDialog.<event_handler>
        if self.rbExtractInsert.GetSelection() == 1:
            dlg_style = wx.OPEN|wx.FILE_MUST_EXIST|wx.CHANGE_DIR
        else:
            dlg_style = wx.SAVE|wx.CHANGE_DIR
        od = wx.FileDialog(self,
                           "Dialogue text file",
                           wildcard="TXT files (*.txt)|*.txt|All Files|*.*",
                           style=dlg_style)
        if od.ShowModal() == wx.ID_OK:
            filename = od.GetPath()
            self.txtCtrlTextFile.SetValue(filename)

    def buttonBrowseGameDir(self, event): # wxGlade: ScummTrDialog.<event_handler>
        fd = wx.DirDialog(self, "Game Directory", os.getcwdu())
        if fd.ShowModal() == wx.ID_OK:
            out_path = fd.GetPath()
            self.txtCtrlGameDir.SetValue(out_path)

    def checkboxLanguage(self, event): # wxGlade: ScummTrDialog.<event_handler>
        if self.cbLanguage.IsChecked():
            self.choiceLanguage.Enable(True)
        else:
            self.choiceLanguage.Enable(False)

    def selectExtract(self):
        self.rbExtractInsert.SetSelection(0)
        for elem in self.output_options_list:
                elem.Enable(True)

    def selectInsert(self):
        self.rbExtractInsert.SetSelection(1)
        for elem in self.output_options_list:
                elem.Enable(False)

    def constructCommandSwitches(self):
        switches = []
        switches.append('-g ' + self.comboGameId.GetValue())
        if self.rbExtractInsert.GetSelection() == 1:
            switches.append('-i')
        else:
            switches.append('-o')
        switches.append('-f "' + self.txtCtrlTextFile.GetValue() + '"')
        switches.append('-p "' + self.txtCtrlGameDir.GetValue() + '"')
        if self.cbWindowsNewlines.IsChecked():
            switches.append('-w')
        if self.cbConvertToAnsi.IsChecked():
            switches.append('-c')
        if self.cbLanguage.IsChecked():
            switches.append(self.choiceLanguage.GetValue())
        if self.cbBinaryMode.IsChecked():
            switches.append('-b')
        if self.rbExtractInsert.GetSelection() == 0:
            if self.cbAddLineHeaders.IsChecked():
                switches.append('-h')
            if self.cbHexCharCodes.IsChecked():
                switches.append('-H')
            if self.cbShowOpcodes.IsChecked():
                switches.append('-I')
            if self.rbPadding.GetSelection != 0:
                if self.rbPadding.GetSelection == 1:
                    paddy = '-a '
                else:
                    paddy = '-A '
                if self.cbPadObjects.IsChecked():
                    paddy += 'o'
                if self.cbPadActors.IsChecked():
                    paddy += 'a'
                if self.cbPadVerbs.IsChecked():
                    paddy += 'v'
                switches.append(paddy)
        return ' '.join(switches)

# end of class ScummTrDialog


