from __future__ import with_statement # requires Python 2.5
import wx
import ssconst
from ui.ids import *
from ui.lists import LeftList, RightList
from ui.menus import MainMenuBar

class MainFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        self.parent = kwds['moofpar']
        del kwds['moofpar']
        wx.Frame.__init__(self, *args, **kwds)



        self.statusbar = self.CreateStatusBar()
        self.panel_1 = wx.Panel(self, -1)
        self.panel_2 = wx.Panel(self, -1)
        self.button_1 = wx.Button(self.panel_1, ID_BUTTON_INSERT, "Map Sound")
        self.button_2 = wx.Button(self.panel_1, ID_BUTTON_REMOVE, "Unmap Sound")
        self.button_edittext = wx.Button(self.panel_1, ID_BUTTON_EDITTEXT, "Edit Text")
        self.button_textdesc = wx.Button(self.panel_1, ID_BUTTON_TEXTDESC, "Edit Description")
        self.button_addvoc = wx.Button(self.panel_2, ID_BUTTON_ADDVOC, "Add Sound")
        self.button_remvoc = wx.Button(self.panel_2, ID_BUTTON_REMVOC, "Remove Sound")
        self.button_repvoc = wx.Button(self.panel_2, ID_BUTTON_REPVOC, "Replace Sound")
        self.button_vocdesc = wx.Button(self.panel_2, ID_BUTTON_VOCDESC, "Edit Description")
        ##self.button_editmetadata = wx.Button(self.panel_2, ID_BUTTON_VOCTAGS, "Edit Metadata")

        self.list_text = LeftList(self)
        self.list_sounds = RightList(self)

        self.__set_properties()
        self.__do_layout()

    def __set_properties(self):
        self.SetTitle("ScummSpeaks " + ssconst.strVersion)
        self.SetMenuBar(MainMenuBar())

    def __do_layout(self):
        # begin wxGlade: MainFrame.__do_layout
        grid_sizer_1 = wx.FlexGridSizer(2, 2, 0, 0)
        sizer_1 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        grid_sizer_1.Add(self.list_text, 1, wx.EXPAND, 0)
        grid_sizer_1.Add(self.list_sounds, 1, wx.EXPAND, 0)

        sizer_1.Add(self.button_1, 0, wx.FIXED_MINSIZE, 0)
        sizer_1.Add(self.button_2, 0, wx.FIXED_MINSIZE, 0)
        sizer_1.Add(self.button_edittext, 0, wx.FIXED_MINSIZE, 0)
        sizer_1.Add(self.button_textdesc, 0, wx.FIXED_MINSIZE, 0)
        self.panel_1.SetAutoLayout(1)
        self.panel_1.SetSizer(sizer_1)
        sizer_1.Fit(self.panel_1)
        sizer_1.SetSizeHints(self.panel_1)

        sizer_2.Add(self.button_addvoc, 0, wx.FIXED_MINSIZE, 0)
        sizer_2.Add(self.button_remvoc, 0, wx.FIXED_MINSIZE, 0)
        sizer_2.Add(self.button_repvoc, 0, wx.FIXED_MINSIZE, 0)
        sizer_2.Add(self.button_vocdesc, 0, wx.FIXED_MINSIZE, 0)
        ##sizer_2.Add(self.button_editmetadata, 1, wx.FIXED_MINSIZE, 0)
        self.panel_2.SetAutoLayout(1)
        self.panel_2.SetSizer(sizer_2)
        sizer_2.Fit(self.panel_2)
        sizer_2.SetSizeHints(self.panel_2)

        grid_sizer_1.Add(self.panel_1, 1, wx.EXPAND, 0)
        grid_sizer_1.Add(self.panel_2, 1, wx.EXPAND, 0)

        self.SetAutoLayout(1)
        self.SetSizer(grid_sizer_1)
        grid_sizer_1.Fit(self)
        grid_sizer_1.SetSizeHints(self)

        # end wxGlade
        grid_sizer_1.AddGrowableCol(0, self.list_text.GetBestSize().width)
        grid_sizer_1.AddGrowableRow(0, 90)
        grid_sizer_1.AddGrowableCol(1, self.list_sounds.GetBestSize().width)
        # begin wxGlade: MainFrame.__do_layout
        self.Layout()
        # end wxGlade
        self.SetSize((600, 400))


# end of class MainFrame
